// getList.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "getList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

INT GetFile(const CString strUrl,const CString strSavePath);
int ConvUtf8ToAnsi(CString& strSource, CString& strChAnsi);

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	if( GetFile("http://live.ttzx.tv/list.html","live.ttzx.tv_list.txt") != 0 )
	{
		printf("can't open http://live.ttzx.tv/list.html");
		return nRetCode;
	}

	CString str;
	char buf[1024*10]={0,};
	FILE *in = fopen("live.ttzx.tv_list.txt","rb");
	FILE *out = fopen("tmp.txt","wb");

	if( !in ) return nRetCode;
	while( 1 )
	{
		if( feof(in) ) break;
		fgets(buf,1024*10,in);

		str = buf;
		CString find,name;
		int p1,p2;
		p1 = str.Find("setmenu");
		if( p1 != -1)
		{
			p1 = str.Find(">", p1);
			p2 = str.Find("<", p1);
			if( p2 != -1 && p1 != -1 && p2 > p1 )
			{
				find = str.Mid(p1+1,p2-p1-1);
				if( strcmp("ʹý̳", find ) != 0 ) 
				{
					//printf("\r\n---%s,\r\n", find);
					fprintf(out,"\r\n---%s,\r\n", find);
				}
			}
		}

		p1 = str.Find("#open");
		if( p1 != -1)
		{
			p1 = str.Find("'", p1);
			p2 = str.Find("'", p1+1);
			if( p2 != -1 && p1 != -1 && p2 > p1 )
			{
				find = str.Mid(p1+1,p2-p1-1);
				name = find;
				//printf("%s,", find);
				fprintf(out,"%s,", find);

				p1 = str.Find("'", p2+1);
				p2 = str.Find("'", p1+1);
				if( p2 != -1 && p1 != -1 && p2 > p1 )
				{
					find = str.Mid(p1+1,p2-p1-1);
					find.Replace("vod:","");
					find.Replace("|$|","\r\n"+name+",");
					//printf("%s\r\n", find);
					fprintf(out,"%s\r\n", find);
				}
			}
		}
	}

	fclose( in );
	fclose( out );

	out = fopen(".txt","wb");
	in = fopen("tmp.txt","rb");
	if( !in || !out ) return nRetCode;
	while( 1 )
	{
		if( feof(in) ) break;
		fgets(buf,1024*10,in);
		str = buf;
		if(!( str.Find("letv:") != -1    ||
		    str.Find("pplive:") != -1  ||
		    str.Find("pa:") != -1      ||
		    str.Find("hunantv") != -1 ) )
		{
			fprintf(out,"%s", str);
		}
	}

	fclose( in );
	fclose( out );
	unlink( "tmp.txt" );
	return nRetCode;
}

#include <afxinet.h>
INT GetFile(const CString strUrl,const CString strSavePath)  
{  
    //鴫  
    if (strUrl.IsEmpty())  
        return -5;  
    if (strSavePath.IsEmpty())  
        return -6;  
  
    unsigned short nPort;       //ڱĿHTTP˿  
    CString strServer, strObject;   //strServerڱַstrObjectڱļ  
    DWORD dwServiceType,dwRet;      //dwServiceTypeڱͣdwRetڱύGET󷵻ص״̬  
  
    //URLȡϢ  
    if(!AfxParseURL(strUrl, dwServiceType, strServer, strObject, nPort))  
    {  
        //ʧܣUrlȷ  
        return -1;  
    }  
    //ӶHTTPӶָڸӵHttpFileļָ룬עdelete  
    CInternetSession intsess;  
    CHttpFile *pHtFile = NULL;  
    //  
    CHttpConnection *pHtCon = intsess.GetHttpConnection(strServer,nPort);  
    if(pHtCon == NULL)  
    {  
        //ʧ  
        intsess.Close();  
        return -2;  
    }  
    //GET  
    pHtFile = pHtCon->OpenRequest(CHttpConnection::HTTP_VERB_GET,strObject);  
    if(pHtFile == NULL)  
    {  
        //GETʧ  
        intsess.Close();  
        delete pHtCon;pHtCon = NULL;  
        return -3;  
    }  
    //ύ  
    pHtFile->SendRequest();  
    //ȡص״̬  
    pHtFile->QueryInfoStatusCode(dwRet);  
    if (dwRet != HTTP_STATUS_OK)  
    {  
        //  
        intsess.Close();  
        delete pHtCon;pHtCon = NULL;  
        delete pHtFile;pHtFile = NULL;  
        return -4;  
    }  
    //ȡļС  
    UINT nFileLen = (UINT)pHtFile->GetLength();  
    DWORD dwRead = 1;       //ڱʶ˶٣Ϊ1Ϊ˽ѭ  
    //  
    CHAR *szBuffer = new CHAR[nFileLen+1];  
    TRY   
    {  
        //ļ  
        CFile PicFile(strSavePath,CFile::modeCreate|CFile::modeWrite|CFile::shareExclusive);  
        while(dwRead>0)  
        {    
            //ջ  
            memset(szBuffer,0,(size_t)(nFileLen+1));  
            //ȡ  
            dwRead = pHtFile->Read(szBuffer,nFileLen);   
            //д뵽ļ  
            //PicFile.Write(szBuffer,dwRead);  
			
			CString utf8 = szBuffer;
			CString ansi;
			ConvUtf8ToAnsi(utf8, ansi);
            int nLen = ansi.GetLength();
			PicFile.Write(ansi,nLen); 
        }  
        //رļ  
        PicFile.Close();  
        //ͷڴ  
        delete []szBuffer;  
        delete pHtFile;  
        delete pHtCon;  
        //ر  
        intsess.Close();  
    }  
    CATCH(CFileException,e)  
    {  
        //ͷڴ  
        delete []szBuffer;  
        delete pHtFile;  
        delete pHtCon;  
        //ر  
        intsess.Close();  
        return -7;          //дļ쳣  
    }  
    END_CATCH  
        return 0;  
} 

int ConvUtf8ToAnsi(CString& strSource, CString& strChAnsi) 
{ 
	if (strSource.GetLength() <= 0) 
		return 0; 
	
	CString strWChUnicode; 
	
	strSource.TrimLeft(); 
	strSource.TrimRight(); 
	strChAnsi.Empty(); 
	
	int iLenByWChNeed = MultiByteToWideChar(CP_UTF8, 0, 
		strSource.GetBuffer(0), 
		strSource.GetLength(), 
		NULL, 0); 
	
	int iLenByWchDone = MultiByteToWideChar(CP_UTF8, 0, 
		strSource.GetBuffer(0), 
		strSource.GetLength(), 
		(LPWSTR)strWChUnicode.GetBuffer(iLenByWChNeed * 2), 
		iLenByWChNeed); 
	
	strWChUnicode.ReleaseBuffer(iLenByWchDone * 2); 
	
	int iLenByChNeed = WideCharToMultiByte(CP_ACP, 0, 
		(LPCWSTR)strWChUnicode.GetBuffer(0), 
		iLenByWchDone, 
		NULL, 0, 
		NULL, NULL); 
	
	int iLenByChDone = WideCharToMultiByte(CP_ACP, 0, 
		(LPCWSTR)strWChUnicode.GetBuffer(0), 
		iLenByWchDone, 
		strChAnsi.GetBuffer(iLenByChNeed), 
		iLenByChNeed, 
		NULL, NULL); 
	
	strChAnsi.ReleaseBuffer(iLenByChDone); 
	
	if (iLenByWChNeed != iLenByWchDone || iLenByChNeed != iLenByChDone) 
		return 1; 
	
	return 0; 
}